import Foundation

extension BusUI {
  public final class TextFieldSource: Formatter {
    /// Выдаём для отображения очищенную от источника строку.
    public override func string(for obj: Any?) -> String? {
      guard let str = obj as? String else { return nil }
      return String(str.dropFirst(2))
    }

    /// Выдаём для использования кодом строку с указанием источника
    /// в виде пользователя `u:`
    public override func getObjectValue(
      _ obj: AutoreleasingUnsafeMutablePointer<AnyObject?>?,
      for string: String,
      errorDescription error: AutoreleasingUnsafeMutablePointer<NSString?>?
    ) -> Bool {
      obj?.pointee = "u:\(string)" as AnyObject
      return true
    }
  }
}
