import Foundation
import MPAKX

public extension MeetupId {
  static func shouldEnableJoin(_ c: MeetupIdContext) -> Bool? {
    guard !c.isLoading.value else { return nil }

    if
      c.textUI.isRecent,
      let sid = formatId(c.textUI.value)
    {
      return sid.count > 2
    }

    if c.join {
      return false
    }
      
    if
      c.isLoading.isRecent,
      !c.isLoading.value
    {
      return true
    }
    
    return nil
  }

  static func shouldFinishLoading(_ c: MeetupIdContext) -> Bool? {
    guard
      c.isLoading.isRecent,
      c.isLoading.value
    else {
      return nil
    }
    return true
  }

  static func shouldResetLoading(_ c: MeetupIdContext) -> Bool? {
    if
      c.join,
      !c.isLoading.value
    {
      return true
    }

    if
      c.finishLoading,
      c.isLoading.value
    {
      return false
    }

    return nil
  }

  static func shouldResetText(_ c: MeetupIdContext) -> String? {
    guard c.textUI.isRecent else { return nil }
    return formatId(c.textUI.value)
  }

  // MARK: - Many

  static func shouldManyResetText(_ c: MeetupIdContext) -> MPAK.Many<String>? {
    /**/print("ИГР MeetupIS.shouldMRT-1")
    guard !c.testTextUI.keys.isEmpty else { return nil }
    /**/print("ИГР MeetupIS.shouldMRT-2")
    var d = [String: String]()
    for id in c.testTextUI.keys {
      let text = c.testTextUI.dict[id] ?? ""
      d[id] = formatId(text)
    }
    let r = MPAK.Many(c.testTextUI.keys, d)
    /**/print("ИГР MeetupIS.shouldMRT-3 r: '\(r)'")
    return r
  }

}
